diff -ruN orig/apt-cacher-1.6.4/debian/apt-cacher.init apt-cacher-1.6.4/debian/apt-cacher.init
--- orig/apt-cacher-1.6.4/debian/apt-cacher.init	2008-04-06 00:02:44.000000000 +0200
+++ apt-cacher-1.6.4/debian/apt-cacher.init	2008-08-04 07:38:07.000000000 +0200
@@ -29,12 +29,29 @@
 	. /etc/default/$NAME
 fi
 
+pidfilepid=
+[ ! -f $PIDFILE ] || pidfilepid=`cat $PIDFILE` || pidfilepid=
+runningpid=`pgrep -f $DAEMON` || runningpid=
+
+if [ "$pidfilepid" != "" -a "$pidfilepid" != "$runningpid" ]
+then
+	pidfilepid=
+	rm -f $PIDFILE
+fi
+
+if [ "$runningpid" != "" -a "$runningpid" != "$pidfilepid" ]
+then
+	pidfilepid=$runningpid
+	echo -n "$pidfilepid" > $PIDFILE
+fi
+
 #
 #	Function that starts the daemon/service.
 #
 d_start() {
 
     if test "$AUTOSTART" = 1 ; then
+        [ -f $PIDFILE ] || \
         start-stop-daemon --start --quiet  \
         --exec $DAEMON -- -R 3 -d -p $PIDFILE $EXTRAOPT
     else
@@ -46,6 +63,7 @@
 #	Function that stops the daemon/service.
 #
 d_stop() {
+        [ ! -f $PIDFILE ] || \
 	start-stop-daemon --stop --quiet --pidfile $PIDFILE \
 		--name $NAME
 }
